﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

/// <summary>
/// Template for adding tutorials into the project
/// </summary>
[System.Serializable]
public class TutorialManager : MonoBehaviour
{
    [SerializeField]
    public GameObject tutorialButton;
    [SerializeField]
    private MovementTut firstTutorial;
    [SerializeField]
    private Button cluesTab;
    [SerializeField]
    private Button statementsTab;
    [SerializeField]
    private Button evidenceTab;

    templateTut[] allTutorials;

    public int tutorialStage;

    private void Awake()
    {
        firstTutorial.eventSetting = TStatus.Started;
        allTutorials = gameObject.GetComponents<templateTut>();
        tutorialStage = 0;
    }

    private void Update()
    {
        for(int i = 0; i < allTutorials.Length; i++)
        {
            if(allTutorials[i].eventSetting == TStatus.Redundant)
            {
                Destroy(allTutorials[i]);
            }
        }
        stageHandler();
    }

    /// <summary>
    /// Displays the button containing the tutorial
    /// </summary>
    /// <param name="tutorialText">The text that the tutorial button is supposed to display</param>
    public void displayTutorial(string tutorialText)
    {
        tutorialButton.SetActive(true);
        tutorialButton.GetComponentInChildren<Text>().text = tutorialText;
        Time.timeScale = 0.0f;
    }

    /// <summary>
    /// Hides the tutorial when the tutorial button is pressed
    /// </summary>
    public void hideTutorial()
    {
        Time.timeScale = 1.0f;
        tutorialButton.SetActive(false);
    }

    private void stageHandler()
    {
        switch (tutorialStage)
        {
            case 0:
                break;
            case 1:
                break;
            case 2:
                break;
            case 3:

                break;
            case 4:
                cluesTab.interactable = true;
                break;
            case 5:
                statementsTab.interactable = true;
                break;
            case 6:
                evidenceTab.interactable = true;
                break;
            case 7:

                break;
            case 8:
                break;
            case 9:
                break;
            case 10:
                break;
            case 11:
                break;
        }
            

    }
}