﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class templateTut : MonoBehaviour
{
    [SerializeField]
    [TextArea]
    protected string startText;
    [SerializeField]
    [TextArea]
    protected string endText;
    public TStatus eventSetting = TStatus.NotStarted;
    protected TutorialManager tutorialManager;
    protected int nextStage = -1;
    [SerializeField]
    private templateTut nextEvent;
    [SerializeField]
    private bool showBeginning;
    [SerializeField]
    private bool showEnding;
    [SerializeField]
    private GameObject selectionBox;

    private void Start()
    {
        //attach the tutorial manager to each of the tutorials
        tutorialManager = gameObject.GetComponent<TutorialManager>();
    }
    private void FixedUpdate()
    {
        if(eventSetting == TStatus.Started)
        {
            startTutorial();
        }
        if(eventSetting == TStatus.Completing)
        {
            endTutorial();
        }
        if(eventSetting == TStatus.Completed)
        {
            if(nextEvent != null)
            {
                nextEvent.eventSetting = TStatus.Started;
            }
            if(nextStage != -1)
            {
                tutorialManager.tutorialStage = nextStage;
            }
            else
            {
                Debug.LogError("Next stage of this tutorial was never set properly.");
            }
            eventSetting = TStatus.Redundant;
        }
    }
    protected void startTutorial()
    {
        if(showBeginning)
        {
            tutorialManager.displayTutorial(startText);
        }
        if (selectionBox != null)
        {
            selectionBox.SetActive(true);
        }
        eventSetting = TStatus.InProgress;
    }

    protected void endTutorial()
    {
        if(showEnding)
        {
            tutorialManager.displayTutorial(endText);
        }
        if(selectionBox != null)
        {
            selectionBox.SetActive(false);
        }
        eventSetting = TStatus.Completed;
    }
}
